<?php
function auth_upload($folder,$exts,$multi=true) {
	//Autorizza l'upload, crea la sessione
	@session_start();
	$_SESSION['mode'] = 'upl';
	$_SESSION['d'] = $folder;
	$_SESSION['exts'] = $exts;
	$_SESSION['multi'] = $multi;
}
function ajax_upload($name,$folder) {
	//Codice per l'upload via ajax
	return <<<F
<div class="ajaxwindow" id="{$name}win"><div class="sub"><iframe width="800" height="600" name='{$name}iframe' id='{$name}iframe' src='' frameborder='0' border='0' ></iframe></div><a href="#" onclick="$('#{$name}win').removeClass('show');" class="closebutton"></a></div>
<script>
var cur_open='';
function close_win(){
	$(cur_open).removeClass('show');
	cur_open = '';
}
function {$name}_upload() {
	if (arguments.length > 0) 
		a = '&call='+arguments[0];
	else	
		a = '';
	document.getElementById("{$name}iframe").src = "zone_develop.html?act=upl&d={$folder}"+a;
	$('#{$name}win').addClass('show');	
	cur_open='#{$name}win';
}
</script>
F;
}
function decompress($file,$folder) {
	//Decompressione di un file zip
	include_once('_proto/pclzip.lib.php');
	$archive = new PclZip($file);
	return ($archive->extract(PCLZIP_OPT_PATH, $folder) == 0);
}
function auth_dirlist($folder) {
	//Autorizza l'utente a vedere le cartelle dentro una cartella
	//Crea la sessione
	session_start();
	$_SESSION['mode'] = 'dir';
	$_SESSION['d'] = $folder;
}
function ajax_dirlist($name,$folder) {
	//Codice per vedere le cartelle via ajax
	return <<<F
<div class="ajaxwindow" id="drl{$name}win"><div class="sub"><iframe width="800" height="600" name='drl{$name}iframe' id='drl{$name}iframe' src='' frameborder='0' border='0' ></iframe></div><a href="#" onclick="$('#drl{$name}win').removeClass('show');" class="closebutton"></a></div>
<script>
var cur_open='';
function close_win(){
	$(cur_open).removeClass('show');
	cur_open = '';
}
function {$name}_dirlist(x) {
	if (x!=null) {
		document.getElementById("drl{$name}iframe").src = "zone_develop.html?act=dir&d={$folder}&call="+x;
		cur_open= '#drl{$name}win';
		$('#drl{$name}win').addClass('show');	
	} else alert('argument invalid');
}
</script>
F;
}
function ajax_filelist($name,$folder,$force=false) {
	//Codice per vedere i files via ajax
	$add = ($force) ? '&fexts=0' : '';
	return <<<F
<div class="ajaxwindow" id="drf{$name}win"><div class="sub"><iframe width="800" height="600" name='drf{$name}iframe' id='drf{$name}iframe' src='' frameborder='0' border='0' ></iframe></div><a href="#" onclick="$('#drf{$name}win').removeClass('show');" class="closebutton"></a></div>
<script>
var cur_open='';
function close_win(){
	$(cur_open).removeClass('show');
	cur_open = '';
}
function {$name}_filelist(x) {
	if (x!=null) {
		document.getElementById("drf{$name}iframe").src = "zone_develop.html?act=fls$add&d={$folder}&call="+x;
		cur_open= '#drf{$name}win';
		$('#drf{$name}win').addClass('show');	
	} else alert('argument invalid');
}
</script>
F;
}
function auth_filelist($folder,$exts) {
	//Autorizza l'utente a vedere i files dentro una cartella (con anche le cartelle)
	//Crea la sessione
	session_start();
	$_SESSION['mode'] = 'dir';
	$_SESSION['d'] = $folder;
	$_SESSION['exts'] = $exts;
}
?>