<?php
/*
	admin_template.html
	Gestione Template
	Ultima modifica : 24/08/12 (v0.6)
*/
include('_proto/func.php');
include("lang/$__lang/a_template.php");
include("lang/$__lang/globals.php");
$pg_title .= ' - '.$__template;
//Download template
if (isset($_GET['down'])) {
	include('_proto/pclzip.lib.php');
	@unlink('temp_'.$_GET['down'].'.zip');
	$archive = new PclZip('temp_'.$_GET['down'].'.zip');
	$dir = (isset($_GET['mob'])) ? 'mobile/template' : 'template';
	$v_list = $archive->create($dir."/{$_GET['down']}/",PCLZIP_OPT_REMOVE_PATH, $dir);
	if ($v_list == 0) {
		die("Error : ".$archive->errorInfo(true));
	}
	download_file('temp_'.$_GET['down'].'.zip');
}
if ($user['level'] < 2) {
	//Eliminazione di un template
	if (isset($_GET['del'])) {
		$deleted = array();
		foreach ($_GET['del'] as $v) {
			$path =  'template/';
			$p = '.trash/template/';
			if ($v['m']=='true') {
				$path = 'mobile/'.$path;
				$p = 'mob/'.$p;
			}
			if (rename($path.$v['n'].'/',$p.$v['n'].'/'))
					$deleted[] = '{"n" : "'.$v['n'].'", "t" : "'.(($v['m']=='true')?'tm':'t').'", "id" : "'.$v['id'].'"}';			
		}
		if (count($deleted) > 0)
			echo '{"r" : "y", "dels" : ['.implode(',',$deleted).']}';
		else
			echo '{"r" : "n"}';
		exit(0);			
	}
}
if (($user['level'] < 3)&&(isset($_GET['tem']))) {
	//Cambio Template
	if (isset($_GET['mob'])) {
		unlink('mobile/_data/compiled.inc.php');
		include('mobile/_data/mobglobals.inc.php');
		$template = $_GET['tem'];
		$f = fopen("mobile/_data/mobglobals.inc.php","w");
		fwrite($f,<<<FILE
<?php
\$logo = "$logo";
\$template = '$template';
\$cmsbanner = '$cmsbanner';
?>
FILE
		);				
	} else {
		$template = $_GET['tem'];
		@unlink('_data/compiled.inc.php');		
		function bool_val($b) { return ($b)? 'true' : 'false';}			
		$f = fopen("_data/cmsglobals.inc.php","w");
		$a = bool_val($aregtos);$b = bool_val($regact);$c = bool_val($advanced); $d = bool_val($niiupdate); $e = bool_val($tooltips); $g = bool_val($offline);
		fwrite($f,<<<FILE
<?php
\$logo = "$logo";
\$favicon = "$favicon";
\$sitemail = '$sitemail';
\$sitemailn = '$sitemailn';
\$sitename = '$sitename';
\$sitedesc = '$sitedesc';
\$sitetags = '$sitetags';
\$template = '$template';
\$GLOBALS['cms_time'] = {$GLOBALS['cms_time']};
\$regmail = '$regmail';
\$regtos = '$regtos';
\$aregtos = $a;
\$regact = $b;
\$cmsbanner = '$cmsbanner';
\$advanced = $c;
\$niiupdate = $d;
\$tooltips = $e;
\$offline = $g;
\$max_backups = $max_backups;
?>
FILE
		);
	}
	fclose($f);
	echo '{"r" : "y"}';
	exit(0);
} elseif(isset($_GET['info'])) {
	if ($_GET['mob']=='true') {
		if (!file_exists('mobile/template/'.$_GET['info'].'/tem.inf'))
			continue;
		$xml = simplexml_load_file('mobile/template/'.$_GET['info'].'/tem.inf');
		$uid = 'tm'.md5(($xml->name).($xml->version));
		$img = '';
		if (isset($xml->image->small)) {
			if (isset($xml->image->big)) $img .= "<a href='mobile/template/".$_GET['info']."/{$xml->image->big}' target='_blank'>";
				$img .= "<img class='cmstmimg' width='200px' src='mobile/template/".$_GET['info']."/{$xml->image->small}'><br>";
			if (isset($xml->image->big)) $img .= "</a>";
		}
		else
			$img = '<a class="cmstmnoimg"></a><br>';
		echo '{"n" : "'.$_GET['info'].'", "mob" : true, "id" : "'.$uid.'", "inf" : "'.($xml->name).' V'.($xml->version).'", "img" : "'.$img.'", "auth" : "'.($xml->creator).'", "site" : "'.($xml->site).'", "desc" : "'.addslashes((isset($xml->description->$__lang)) ? $xml->description->$__lang : $xml->description->default).'"}';
	} else {
		if (!file_exists('template/'.$_GET['info'].'/tem.inf'))
			continue;
		$xml = simplexml_load_file('template/'.$_GET['info'].'/tem.inf');
		$uid = 't'.md5(($xml->name).($xml->version));
		$img = '';
		if (isset($xml->image->small)) {
			if (isset($xml->image->big)) $img .= "<a href='template/".$_GET['info']."/{$xml->image->big}' target='_blank'>";
				$img .= "<img class='cmstmimg' width='200px' src='template/".$_GET['info']."/{$xml->image->small}'><br>";
			if (isset($xml->image->big)) $img .= "</a>";
		}
		else
			$img = '<a class="cmstmnoimg"></a><br>';
		echo '{"n" : "'.$_GET['info'].'", "mob" : false, "id" : "'.$uid.'", "inf" : "'.($xml->name).' V'.($xml->version).'", "img" : "'.$img.'", "auth" : "'.($xml->creator).'", "site" : "'.($xml->site).'", "desc" : "'.addslashes((isset($xml->description->$__lang)) ? $xml->description->$__lang : $xml->description->default).'"}';
	}
} elseif (isset($_GET['show_first'])) {	
	include('_data/cmsglobals.inc.php');
	//Aggiungere tasto installa
	echo '<div class="ui-widget-header ui-corner-all pgtoolbar"><a class="a-button hint" id="template_setup" onclick="$( \'#upload_exts\').dialog(\'open\')" title="'.$__install.'"></a><a class="a-button hint" id="template_del" onclick="template_del()" title="'.$__d_del.'"></a><a class="a-button hint" id="template_down" onclick="template_down()" title="'.$__down.'"></a></div>
	<script>
	$( "#template_del" ).button().find("span").addClass("imgdelbig imgdelbig_in").css("padding",0);
	$( "#template_down" ).button().find("span").addClass("imgdownbig imgdownbig_in").css("padding",0);
	$( "#template_setup" ).button().find("span").addClass("imgsetup").css("padding",0);
	</script>
	<div class="templates window_sub">
	<ol class="" title="" id="templates_content">
	<div class="separator no_selectable pre_pc"><div class="pre"><hr></hr></div>'.$__p_pc.'<div class="after"><hr></hr></div></div>';	
	foreach(list_dir('template') as $dir) {
		if (!file_exists("template/$dir/tem.inf"))
			continue;
		$xml = simplexml_load_file("template/$dir/tem.inf");
		$uid = 't'.md5(($xml->name).($xml->version));
		if ($dir == $template) {
			echo '<script>var tem_pc_in_use="'.$uid.'"</script>';
			$use = '<span class="template_in_use">'.$__in_u_this.'</span>';
			$cl = 'nodelete';
		} else {
			$use = $__u_this;
			$cl = '';
		}
		echo'<li onclick="select_tem(this,false)" class="element drop_on_trash '.$cl.'" title="'.$dir.'" id="'.$uid.'"><b class="text">'.($xml->name).' V'.($xml->version).'</b>';
		if (isset($xml->image->small)) {
			if (isset($xml->image->big)) echo "<a href='template/$dir/{$xml->image->big}' target='_blank'>";
				echo "<img class='cmstmimg' width='200px' src='template/$dir/{$xml->image->small}'><br>";
			if (isset($xml->image->big)) echo "</a>";
		}
		else
			echo '<a class="cmstmnoimg"></a><br>';
		$desc = (isset($xml->description->$__lang)) ? $xml->description->$__lang : $xml->description->default;
		echo '<a class="resize" onclick="elem_resize(\''.$uid.'\',\'t\')"></a><div class="extra">'.$__by.' : <b>'.($xml->creator).'</b><br><br><a href="http://'.($xml->site).'" target="_blank">'.($xml->site).'</a><br><br>'.$desc.'<br><br>
    </div><b class="bar"><a href="javascript:change_template(\''.$dir.'\',false,\''.$uid.'\')">'.$use.'</a></b></li>';
	}
	echo '<div class="separator no_selectable pre_mob"><div class="pre"><hr></hr></div>'.$__p_mob.'<div class="after no_selectable"><hr></hr></div></div>';
	include('mobile/_data/mobglobals.inc.php');
	foreach(list_dir('mobile/template') as $dir) {
		if (!file_exists("mobile/template/$dir/tem.inf"))
			continue;
		$xml = simplexml_load_file("mobile/template/$dir/tem.inf");
		$uid = 'tm'.md5(($xml->name).($xml->version));
		if ($dir == $template) {
			echo '<script>var tem_mob_in_use="'.$uid.'"</script>';
			$use = '<span class="template_in_use">'.$__in_u_this.'</span>';
			$cl = 'nodelete';
		} else {
			$use = $__u_this;
			$cl = '';
		}
		echo'<li onclick="select_tem(this,true)" class="element drop_on_trash is_mobile '.$cl.'" title="'.$dir.'" id="'.$uid.'"><b class="text">'.($xml->name).' V'.($xml->version).'</b>';
		if (isset($xml->image->small)) {
			if (isset($xml->image->big)) echo "<a href='mobile/template/$dir/{$xml->image->big}' target='_blank'>";
				echo "<img class='cmstmimg' width='200px' src='mobile/template/$dir/{$xml->image->small}'><br>";
			if (isset($xml->image->big)) echo "</a>";
		}
		else
			echo '<a class="cmstmnoimg"></a><br>';
		
		
		$desc = (isset($xml->description->$__lang)) ? $xml->description->$__lang : $xml->description->default;
		echo '<a class="resize" onclick="elem_resize(\''.$uid.'\',\'t\')"></a><div class="extra">'.$__by.' : <b>'.($xml->creator).'</b><br><br><a href="'.($xml->site).'" target="_blank">'.($xml->site).'</a><br><br>'.$desc.'<br><br>
    </div><b class="bar"><a href="javascript:change_template(\''.$dir.'\',true,\''.$uid.'\')">'.$use.'</a></b></li>';
	}
	echo '</ol></div><script>
		var templates_selected = [];
		make_dragable_t();
		$("#templates_content").selectable({ filter: "li" ,  cancel: ".no_selectable,a" ,stop: on_select_templates })
		</script>';
	if ($tooltips) echo '<script>make_tooltip();</script>';
} else header('Location: admin.html?open=template');
?>