<?php
/*
	admin_component.html
	Gestione Componenti
	Ultima modifica : 29/08/12 (v0.6.0.1)
*/
if ($user['level'] < 3) {
	include('_proto/func.php');
	include("lang/$__lang/a_component.php");
	include("lang/$__lang/globals.php");
	$pg_title .= ' - '.$__component;
	if ($user['level'] < 2) {
		if (isset($_GET['del'])) {	
			//Disisintallazione di un componente
			$deleted = array();
			foreach ($_GET['del'] as $v) {
				if (rename('com/'.$v['n'].'/','.trash/com/'.$v['n'].'/')) {
					rename('com/'.$v['n'].'.php','.trash/com/'.$v['n'].'.php');
					//Eliminazione del preload
					include('_data/preloader.php');
					if (isset($ext_preload['com'][$v['n']])) {
						unset($ext_preload['com'][$v['n']]);
						save_preload($ext_preload);
					}
					$deleted[] = '{"n" : "'.$v['n'].'", "id" : "'.$v['id'].'", "m" : '.$v['m'].'}';
				}
			}
			if (count($deleted) > 0)
				echo '{"r" : "y", "dels" : ['.implode(',',$deleted).']}';
			else
				echo '{"r" : "n"}';
			exit(0);
			//if (file_exists('com/'.$_GET['del'].'/uninstall.php')) include 'com/'.$_GET['del'].'/uninstall.php';
		}
	}
	if (($user['level'] < 2)&&(isset($_GET['dinstall']))) {
		//Completamento installazione componente (ed eliminazione del file di installazione)
		unlink('com/'.$_GET['dinstall'].'/install.php');
		echo "<script>parent.success_installed('c','{$_GET['dinstall']}');</script>";
		exit(0);	
	}
	if (($user['level'] < 2)&&(isset($_GET['install']))) {
		//Inclusione dei files di installazione del componente
		include('com/'.$_GET['install'].'/install.php');
		exit(0);
	} elseif (isset($_GET['conf'])||isset($_POST['conf'])) {
		//Configurazione di un componente
		$com = (isset($_GET['conf'])) ? $_GET['conf'] : $_POST['conf'];
		echo '<script type="text/javascript" src="script.js"></script><script type="text/javascript" src="js/jquery.js"></script><script type="text/javascript" src="js/jquery-ui.js"></script><link rel="stylesheet" type="text/css" href="nii.css"/><link rel="stylesheet" type="text/css" href="js/jquery-ui.css"/>';
		if (file_exists("com/$com/comconf.php")) 
			include("com/$com/comconf.php");
	} elseif (isset($_GET['info'])) {
		if (!file_exists('com/'.$_GET['info'].'/com.inf'))
			continue;
		$xml = simplexml_load_file('com/'.$_GET['info'].'/com.inf');
		$uid = 'c'.md5(($xml->name).($xml->version));
		$img = '';
		if (isset($xml->image->small)) {
			if (isset($xml->image->big)) $img .= "<a href='com/".$_GET['info']."/{$xml->image->big}' target='_blank'>";
				$img .= "<img class='cmscmimg' width='200px' src='com/".$_GET['info']."/{$xml->image->small}'><br>";
			if (isset($xml->image->big)) $img .= "</a>";
		}
		else
			$img = '<a class="cmscmnoimg"></a><br>';
		$mobile = file_exists('com/'.$_GET['info'].'/.mobile');
		$omobile = file_exists('com/'.$_GET['info'].'/.onlymobile');
		echo '{"n" : "'.$_GET['info'].'", "id" : "'.$uid.'", "inf" : "'.($xml->name).' V'.($xml->version).'", "img" : "'.$img.'", "auth" : "'.($xml->creator).'", "site" : "'.($xml->site).'", "desc" : "'.str_replace("\n", '\n', addcslashes(((isset($xml->description->$__lang)) ? $xml->description->$__lang : $xml->description->default), "\v\t\n\r\f\"\\/")).'", "conf" : '.((isset($xml->config))?'true':'false').', "m" : '.(($mobile)?'true':'false').', "om" : '.(($omobile)?'true':'false').'}';
	} elseif (isset($_GET['show_first'])) {
		echo '<div class="ui-widget-header ui-corner-all pgtoolbar"><a class="a-button hint" id="com_setup" onclick="$( \'#upload_exts\').dialog(\'open\')" title="'.$__install.'"><a class="a-button hint" id="com_del" onclick="com_del()" title="'.$__d_del.'"></a></div>
		<script>
		$( "#com_del" ).button().find("span").addClass("imgdelbig imgdelbig_in").css("padding",0);
		$( "#com_setup" ).button().find("span").addClass("imgsetup").css("padding",0);
		</script>
		<div class="coms window_sub">
		<ol class="hint" title="'.$__comdesc.'" id="coms_content">
		<div class="separator no_selectable pre_pc"><div class="pre"><hr></hr></div>'.$__p_pc.'<div class="after"><hr></hr></div></div>';
		$mob='';
		foreach(list_dir('com') as $dir) {
			$this_com = '';
			if (!file_exists("com/$dir/com.inf"))
				continue;
			//Mostro le informazioni di ogni componente
			if (file_exists("com/$dir/install.php"))
				echo '<script>new_install({"z" : "component", "n" : "'.$dir.'"},true)</script>';
			$xml = simplexml_load_file("com/$dir/com.inf");		
			$uid = 'c'.md5(($xml->name).($xml->version));
			$mobile = file_exists("com/$dir/.mobile");
			$omobile = file_exists("com/$dir/.onlymobile");	
			$fpart = '<li onclick="select_com(this)" class="element drop_on_link drop_on_trash" title="'.$dir.'" id="'.$uid.'"><b class="text">'.($xml->name).' V'.($xml->version).'</b>';
			if ($mobile||$omobile)
				$mob .= '<li onclick="select_com(this)" class="element is_mobile drop_on_link_m drop_on_trash" title="'.$dir.'" id="'.$uid.'"><b class="text">'.($xml->name).' V'.($xml->version).'</b>';
			if (isset($xml->image->small)) {
				if (isset($xml->image->big)) $this_com .= "<a href='com/$dir/{$xml->image->big}' target='_blank'>";
					$this_com .= "<img class='cmscmimg' width='200px' src='com/$dir/{$xml->image->small}'><br>";
				if (isset($xml->image->big)) $this_com .= "</a>";
			}
			else
				$this_com .= '<a class="cmscmnoimg"></a><br>';
			$desc = (isset($xml->description->$__lang)) ? $xml->description->$__lang : $xml->description->default;
			$config = (isset($xml->config))? '<a href="javascript:exts_config(\'component\',\''.$dir.'\')">'.$__config.'</a>':'';
			$this_com .= '<a class="resize" onclick="elem_resize(\''.$uid.'\',\'c\')"></a><div class="extra">'.$__by.' : <b>'.($xml->creator).'</b><br><br><a href="http://'.($xml->site).'" target="_blank">'.($xml->site).'</a><br>'.$desc.'</div><b class="bar">'.$config.'</b></li>';
			if ($mobile||$omobile)
				$mob .= $this_com;
			if (!$omobile)
				echo $fpart.$this_com;
		}
		echo '<div class="separator no_selectable pre_mob"><div class="pre"><hr></hr></div>'.$__p_mob.'<div class="after"><hr></hr></div></div>'.$mob.'</ol></div><script>var coms_selected = [];
			make_dragable_c();
			$("#coms_content").selectable({ filter: "li" ,  cancel: ".no_selectable,a" ,stop: on_select_coms })</script>
			';
		if ($tooltips) echo '<script>make_tooltip();</script>';
	} else header('Location: admin.html?open=component');
} else echo $__405;
?>