<?php
/*
	admin_module.html
	Gestione Moduli
	Ultima modifica : 24/08/12 (v0.6)
*/
if ($user['level'] < 3) {
	include('_proto/func.php');
	include("lang/$__lang/a_module.php");
	include("lang/$__lang/globals.php");
	$pg_title .= ' - '.$__module;
	if ($user['level'] < 2) {
		//Eliminazione di un modulo
		if (isset($_GET['del'])) {	
			//Disisintallazione di un componente
			$deleted = array();
			foreach ($_GET['del'] as $v) {
				if (rename('mod/'.$v['n'].'/','.trash/mod/'.$v['n'].'/'))
					$deleted[] = '{"n" : "'.$v['n'].'", "id" : "'.$v['id'].'"}';			
			}
			if (count($deleted) > 0)
				echo '{"r" : "y", "dels" : ['.implode(',',$deleted).']}';
			else
				echo '{"r" : "n"}';
			exit(0);
		}		
	}
	if (($user['level'] < 3)&&(isset($_GET['dinstall']))) {
		unlink('mod/'.$_GET['dinstall'].'/install.php');
		echo "<script>parent.success_installed('m','{$_GET['dinstall']}');</script>";
		exit(0);	
	}
	if (($user['level'] < 3)&&(isset($_GET['install']))) {
		include('mod/'.$_GET['install'].'/install.php');
		exit(0);
	} else if (isset($_GET['conf'])||isset($_POST['conf'])) {
		$mod = (isset($_GET['conf'])) ? $_GET['conf'] : $_POST['conf'];
		echo '<script type="text/javascript" src="script.js"></script><script type="text/javascript" src="js/jquery.js"></script><script type="text/javascript" src="js/jquery-ui.js"></script><link rel="stylesheet" type="text/css" href="nii.css"/><link rel="stylesheet" type="text/css" href="js/jquery-ui.css"/>';
		if (file_exists("mod/$mod/modconf.php")) 
			include("mod/$mod/modconf.php");
	} elseif (isset($_GET['info'])) {
		if (!file_exists('mod/'.$_GET['info'].'/mod.inf'))
			continue;
		$xml = simplexml_load_file('mod/'.$_GET['info'].'/mod.inf');
		$uid = 'm'.md5(($xml->name).($xml->version));
		$img = '';
		if (isset($xml->image->small)) {
			if (isset($xml->image->big)) $img .= "<a href='mod/".$_GET['info']."/{$xml->image->big}' target='_blank'>";
				$img .= "<img class='cmsmdimg' width='200px' src='mod/".$_GET['info']."/{$xml->image->small}'><br>";
			if (isset($xml->image->big)) $img .= "</a>";
		}
		else
			$img = "<a class='cmsmdnoimg'></a><br>";
		echo '{"n" : "'.$_GET['info'].'", "id" : "'.$uid.'", "inf" : "'.($xml->name).' V'.($xml->version).'", "img" : "'.$img.'", "auth" : "'.($xml->creator).'", "site" : "'.($xml->site).'", "desc" : "'.str_replace("\n", '\n', addcslashes(((isset($xml->description->$__lang)) ? $xml->description->$__lang : $xml->description->default), "\v\t\n\r\f\"\\/")).'", "conf" : '.((isset($xml->config))?'true':'false').'}';
	} elseif (isset($_GET['show_first'])) {
		//Lista Moduli
		echo '<div class="ui-widget-header ui-corner-all pgtoolbar"><a class="a-button hint" id="mod_setup" onclick="$( \'#upload_exts\').dialog(\'open\')" title="'.$__install.'"><a class="a-button hint" id="mod_del" onclick="mod_del()" title="'.$__d_del.'"></a></div>
		<script>
		$( "#mod_del" ).button().find("span").addClass("imgdelbig imgdelbig_in").css("padding",0);
		$( "#mod_setup" ).button().find("span").addClass("imgsetup").css("padding",0);
		</script>
		<div class="mods window_sub">
		<ol style="height:90%" class="hint" title="'.$__moddesc.'" id="mods_content">';
		foreach(list_dir('mod') as $dir) {
			if (!file_exists("mod/$dir/mod.inf"))
				continue;
			if (file_exists("mod/$dir/install.php"))
				echo '<script>new_install({"z" : "module", "n" : "'.$dir.'"},true)</script>';
			$xml = simplexml_load_file("mod/$dir/mod.inf");
			$uid = 'm'.md5(($xml->name).($xml->version));
			echo '<li onclick="select_mod(this)" class="element drop_on_menu drop_on_trash" title="'.$dir.'" id="'.$uid.'"><b class="text">'.($xml->name).' V'.($xml->version).'</b>';
			if (isset($xml->image->small)) {
				if (isset($xml->image->big)) echo "<a href='mod/$dir/{$xml->image->big}' target='_blank'>";
				echo "<img class='cmsmdimg' width='200px' src='mod/$dir/{$xml->image->small}'><br>";
				if (isset($xml->image->big)) echo "</a>";
			}
			else
				echo "<a class='cmsmdnoimg'></a><br>";
			$desc = (isset($xml->description->$__lang)) ? $xml->description->$__lang : $xml->description->default;
			$config = (isset($xml->config))? '<a href="javascript:exts_config(\'module\',\''.$dir.'\')">'.$__config.'</a>':'';
			echo '<a class="resize" onclick="elem_resize(\''.$uid.'\',\'m\')"></a><div class="extra">'.$__by.' : <b>'.($xml->creator).'</b><br><br><a href="http://'.($xml->site).'" target="_blank">'.($xml->site).'</a><br>'.$desc.'</div><b class="bar">'.$config.'</b></li>';
		}
		echo '</ol><script>var mods_selected = [];
			make_dragable_m();
			$("#mods_content").selectable({ filter: "li" ,  cancel: ".no_selectable,a" ,stop: on_select_mods })</script>';
			
			
			
			/*i
			$desc = (isset($xml->description->$__lang)) ? $xml->description->$__lang : $xml->description->default;
			$in = in_menu($dir,$menu);
			if (!$in)	//Nel caso non sia ancora stato collegato al menu			
				$extra = ' <a class="imgtmn hint" id="'.md5($dir).'" title="'.$__d_tmenu.'" href="javascript:add_menu(\''.$dir.'\',\''.md5($dir).'\')"></a>';
			else 
				$extra = ' <a class="imgrmn hint" id="'.md5($dir).'" title="'.$__d_rmenu.'" href="javascript:rem_menu(\''.$dir.'\',\''.$in[0].'\',\''.$in[1].'\',\''.md5($dir).'\')"></a>'; 
			echo <<<X
	<div class="cmsmod">
	<h3 class='cmsmdname'>{$xml->name} V{$xml->version} <a href='admin_module.html?del=$dir' class='imgdel normal-link'></a> $extra</h3>
	$__by : {$xml->creator}<br>
	<a href="{$xml->site}">{$xml->site}</a><br>
	$desc<br><br>
	X;
			if (isset($xml->config)) echo "<b><a href='admin_module.html?conf=$dir' class='normal-link'>$__config</a></b><br><br>"; else echo "<br><br>";
			echo '</div>';		
		}*/
		if ($tooltips) echo '<script>make_tooltip();</script>';
	} else header('Location: admin.html?open=module');
} else echo $__405;
?>